<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8">
    <meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="0" />
    <title>QuEST Local Control Panel</title>

    <link rel="stylesheet" href="styles/control-panel.css" type="text/css">
    <link rel="stylesheet" href="styles/jquery-ui-1.10.3.custom.css" type="text/css">

    <script src="scripts/jquery-1.9.1.js"></script>
    <script src="scripts/jquery-ui-1.10.3.custom.min.js"></script>
    <script src="scripts/kinetic-v5.1.0.min.js"></script>
    <script src="scripts/CRC16-CCITT.js"></script>
    <script src="scripts/qlcp-panel.js"></script>
  </head>

  <body>
    <div id="headerWrapper" onclick="" class="noselect">
      <div id="header">
        <div id="logo">
          <img src="images/qlcp_icon.png" style="width: 90%; margin-top: -3px" draggable="false"/>
        </div>
        <div id="title">
          <h1 id="headerTitle">QuEST Local Control Panel</h1>
        </div>
      </div>
      <img id="link_status" style="float: right; margin-top: 13px; margin-right: 10px" src="images/error24px.png" draggable="false"/>
      <div style="float: right; margin-top: 18px; margin-right: 5px; margin-left: 30px"><h4>Link</h4></div>
      <div style="float: right; margin-right: 10px"><h1 id="system_time"></h1></div>
    </div>

    <div id="buttonBackground" onclick="" class="noselect">
      <div id="designButtons" style="float: left; visibility: hidden" onclick="ClearPreviousSelection()">
        <button class="buttonStyle" id="open_button" title="Open" type="button" onclick="OpenPanelFile()"><img class="buttonImage" src="images/openfolder24px.png" align="absmiddle"></button>
        <button class="buttonStyle" id="save_button" title="Save" type="button" onclick="SavePanel()"><img class="buttonImage" src="images/save24px.png" align="absmiddle"></button>
        <button class="buttonStyle" id="clear_all_button" title="Clear All" type="button" onclick="ShowClearAllDialog()"><img class="buttonImage" src="images/eraser24px.png" align="absmiddle"></button>
        <button class="buttonStyle" id="run_button" title="Run" type="button" onclick="RunMode()"><img class="buttonImage" src="images/run24px.png" align="absmiddle"></button>
        <h4 style="float: left; margin-left: 30px">Design Style:<select id="design_style_option" onchange="SetPanelStyle(true)" style="width: 140px; margin-top: 13px; margin-left: 5px; margin-right: 8px"><option>Components</option><option>Mosaic Tiles</option></select></h4>
      </div>
      <div id="componentButtons" style="float: left; visibility: hidden">
        <button class="buttonStyle" id="properties_button" title="Show Properties" type="button" onclick="ShowPropertiesDialog()" style="margin-left: 25px"><img class="buttonImage" src="images/settings.png" align="absmiddle"></button>
        <button class="buttonStyle" id="icons_button" title="Tiles" type="button" onclick="ShowIconsDialog()"><img class="buttonImage" src="images/icons24px.png" align="absmiddle"></button>
        <button class="buttonStyle" id="text_button" title="Drop Text" type="button" onclick="ToggleDropComponentButtons(id)"><img class="buttonImage" src="images/text24px.png" align="absmiddle"></button>
        <button class="buttonStyle" id="led_button" title="Drop LED" type="button" onclick="ToggleDropComponentButtons(id)"><img class="buttonImage" src="images/LED.png" align="absmiddle"></button>
        <button class="buttonStyle" id="pb_button" title="Drop Pushbutton" type="button" onclick="ToggleDropComponentButtons(id)"><img class="buttonImage" src="images/pushbutton.png" align="absmiddle"></button>
        <button class="buttonStyle" id="pb_square_button" title="Drop Square Pushbutton" type="button" onclick="ToggleDropComponentButtons(id)"><img class="buttonImage" src="images/square_pb.png" align="absmiddle"></button>
        <button class="buttonStyle" id="togSw_button" title="Drop Toggle Switch" type="button" onclick="ToggleDropComponentButtons(id)"><img class="buttonImage" src="images/toggle_switch.png" align="absmiddle"></button>
        <button class="buttonStyle" id="keyswitch_button" title="Drop Key Switch" type="button" onclick="ToggleDropComponentButtons(id)"><img class="buttonImage" src="images/keyswitch.png" align="absmiddle"></button>
        <button class="buttonStyle" id="quadrilateral_button" title="Drop Quadrilateral" type="button" onclick="ToggleDropComponentButtons(id)"><img class="buttonImage" src="images/Rectangle.png" align="absmiddle"></button>
        <button class="buttonStyle" id="arrow_button" title="Drop Arrow" type="button" onclick="ToggleDropComponentButtons(id)"><img class="buttonImage" src="images/arrow.png" align="absmiddle"></button>
        <button class="buttonStyle" id="timer_button" title="Drop Timer" type="button" onclick="ToggleDropComponentButtons(id)"><img class="buttonImage" src="images/Timer_icon.png" align="absmiddle"></button>
        <button class="buttonStyle" id="duplicate_button" title="Duplicate" type="button" onclick="Duplicate()" style="margin-left: 45px"><img class="buttonImage" src="images/copy.png" align="absmiddle"></button>
      </div>
      <div style="float: left; visibility: hidden">
        <button class="buttonStyle" id="increase_button" title="Increase Background Image Size" type="button" onclick="IncreaseBackgroundImageSize()"><img class="buttonImage" src="images/image_increase_size.png" align="absmiddle"></button>
        <button class="buttonStyle" id="decrease_button" title="Decrease Background Image Size" type="button" onclick="DecreaseBackgroundImageSize()"><img class="buttonImage" src="images/image_decrease_size.png" align="absmiddle"></button>
        <button class="buttonStyle" id="remove_background_button" title="Remove Background Image" type="button" onclick="RemoveBackgroundImage()"><img class="buttonImage" src="images/remove_image.png" align="absmiddle"></button>
        <h4 id="position_display" style="float: right; margin-top: 13px; margin-left: 45px">Position: <input type="text" id="position_display_textbox" readonly style="width: 140px;"></h4>
      </div>

      <div id="runButtons" style="position: absolute; visibility: hidden">
        <button class="buttonStyle" id="design_button" title="Design" type="button" onclick="DesignMode()"><img class="buttonImage" src="images/design22px.png" align="absmiddle"></button>
        <button class="buttonStyle" id="send_all_button" title="Send All Controls" type="button" onclick="SendAllControls()"><img class="buttonImage" src="images/send_controls24px.png" align="absmiddle"></button>
        <button class="buttonStyle" id="clear_controls_button" title="Clear All Controls" type="button" onclick="ClearAllControls()"><img class="buttonImage" src="images/clear_controls24px.png" align="absmiddle"></button>
      </div>
      <div style="position: fixed; top: calc(100vh - 97px); left: calc(100% - 72px); background-color: #222222; padding: 5px" id="fullscreen_button" title="Full Screen" onclick="ToggleFullScreen()"><img id="fullscreen_image" class="buttonImage" src="images/full_screen.png" align="absmiddle"></div>
    </div>

    <!-- Create the container for scrolling the soft panel within the viewport. -->
    <div id="scroll_container">
      <div id="mainContent">
        <!-- Create the container to hold the component layer. -->
        <div id="component_container"></div>
        <div id="lcp_background"></div>
        <!-- Create the divs to hold the grid lines and the icon grid. -->
        <!-- They must be separate to be able to show and hide grid lines and still maintain selection and drag/drop capability -->
        <!-- Note the importance of the z-index attribute in the control-panel.css file. This is what creates the layers for icons, grid lines, and text -->
        <div id="grid_lines"></div>
        <div id="grid"></div>
        <!-- this is a hidden div that is used for building icons during the open panel file process -->
        <div id="temp" style="visibility: hidden"></div>
        <div id="gridCellSize" class="gridLines" style="visibility: hidden"></div>
      </div>
    </div>

    <!-- create the dialog box divs -->
    <div id="icons_dialog" title="Tiles"></div>
    <div id="properties_dialog" title="Properties"></div>
    <div id="controls_dialog" title="Controls"></div>
    <div id="clear_all_dialog" title="Clear All"></div>
    <div id="message_dialog" title=""></div>
    <div id="passcode_dialog" title="Passcode"></div>

    <div id="footerWrapper" class="noselect">
      <div id="footerContent">
        <h3 style="float: left">&#169; 2019 QuEST Rail LLC., All Rights Reserved</h3>
        <h4 id="vsnInfo" style="float: right; padding-right: 30px; padding-top: 7px"></h4>
        <h4 id="panel-crc" style="float: right; padding-right: 30px; padding-top: 7px; visibility: hidden;">Panel CRC: 0x0000</h4>
      </div>
    </div>

    <script>
      //Create the stage for component and text.
      //46 pixels is based on the icon size, grid size, overlap of grids, etc.
      var stage = new Kinetic.Stage({
        container: 'component_container',
        width: nbrCols * 44,
        height: nbrRows * 44
      });

      //create the component layer and add it to the stage
      var component_layer = new Kinetic.Layer();
      var bgImage_layer = new Kinetic.Layer();
      stage.add(bgImage_layer, component_layer);

      var scrollContainer = document.getElementById('scroll_container');
      scrollContainer.addEventListener('scroll', function () {
        var dx = scrollContainer.scrollLeft;
        var dy = scrollContainer.scrollTop;
        stage.container().style.transform = 'translate(' + dx + 'px, ' + dy + 'px)';
        stage.x(-dx);
        stage.y(-dy);
        stage.batchDraw();
      });

      //The following three mouse event routines are for selecting multiple components on the stage
      //(on the component layer). The reason the event listeners are bound to the stage is so
      //they only fire when the event occurs in the stage area, not the title, menu, or footer areas.

      //This event depends on bubbling of events from the component elements on the component layer.
      //It depends on the component setting the selected Id and mouseDownOnComponent flag first.
      //This routine is only used for design mode.
      stage.getContent().addEventListener("mousedown", function ()
      {
        if (designMode)
        {
          //If the mouse down event was on the stage and not on a component, and if
          //there is a drop mode active, add the component to the stage.
          //AddComponent function will check drop mode to determine which component to add.
          if (!mouseDownOnComponent)
          {
            allow_bgImg_selection = true;
            // console.log("clear selected group of components");
            //Need to clear any previously selected group of components
            ClearSelectedComponents();

            if (dropMode['none']) {

              draggingToSelectComponents = true;
              // dkh tmp - stop selection box when dragging background image.
              if (bgImage_layer.hasChildren()) {
                if (bgImage_layer.getChildren()[0].draggable()) {
                  draggingToSelectComponents = false;
                }
              }
            }

            //get the current mouse position
            var mousepos = stage.getPointerPosition();

            //If drop mode is not none, add the component to the layer at the current mouse position.
            if (!dropMode['none'])
            {
              var Component = AddComponent(mousepos.x, mousepos.y, ++idNbr);
              ShowSelectedComponent(Component);
            }
            else
            {
              ClearPreviousSelection();
            }
          }
          else //mouse down was on a component
          {
            allow_bgImg_selection = false;
            //If multiple components were selected (array is not empty),
            //set flag if a component within the group has been selected.
            for (i = 0; i < selectedComponents.length; i++)
            {
              if (selectedComponents[i].attrs.id === selectedId)
              {
                compInSelectedGroup = true;
              }
            }
            //If the mouse down event hit a component in a selected group,
            //get the mouse position to start keeping track of the move distance (delta x, delta y).
            if (compInSelectedGroup)
            {
              var mousepos = stage.getPointerPosition();
              initX = mousepos.x;
              initY = mousepos.y;
            }
            else
            {
              //Need to clear any previously selected group of components
              ClearSelectedComponents();
            }
          }
        }
      });

      //This function depends on requestAnimationFrame to redraw the component layer.
      //This routine is only used for design mode.
      stage.getContent().addEventListener('mousemove', function ()
      {
        if (designMode)
        {
          if (draggingToSelectComponents)
          {
            CreateSelectionBox();
          }

          //If a group is selected and a component in the group has been selected,
          //start moving the group of selected components.
          if (selectedComponents.length > 0 && compInSelectedGroup)
          {
            //Get the current mouse position and determine the delta x and y values.
            var mousepos = stage.getPointerPosition();
            deltaX = mousepos.x - initX;
            deltaY = mousepos.y - initY;

            //Move each of the components in the selection.
            for (i = 0; i < selectedComponents.length; i++)
            {
              //Move all other components. The selected one will move when dragged.
              if (selectedComponents[i].attrs.id !== selectedId)
              {
                selectedComponents[i].position({
                  x: selectedComponents[i].getPosition().x + deltaX,
                  y: selectedComponents[i].getPosition().y + deltaY
                });
              }
            }

            //Reset coordinates for the next move event.
            initX = mousepos.x;
            initY = mousepos.y;
          }

          //show the currently selected component's x,y position
          if (selectedComponents.length == 0 && !mouseDownOnComponent) {
            if (bgImage_layer.hasChildren()) {
              if (bgImage_layer.getChildren()[0].draggable()) {
              document.getElementById("position_display_textbox").value = "  x = " +
              bgImage_layer.getChildren()[0].x() + ", y = " + bgImage_layer.getChildren()[0].y();
            }
          }
          }

          if (selectedId !== "")
          {
            var component = stage.get('#'+ selectedId)[0];
            ShowComponentPosition(component);

            if ($( "#properties_dialog" ).dialog( "isOpen" ))
            {
              document.getElementById("x_pos_value").value = component.attrs.x;
              document.getElementById("y_pos_value").value = component.attrs.y;
            }
          }

        }
      });

      //This function depends on requestAnimationFrame to redraw the component layer.
      //This routine is only used for design mode.
      stage.getContent().addEventListener("mouseup", function ()
      {
        if (designMode)
        {
          //When the mouse is released after dragging to select
          //components (flag is still true), determine which
          //components are within the selection box and show them as selected.
          if (draggingToSelectComponents && !mouseDownOnComponent)
          {
            draggingToSelectComponents = false;

            //clear the selection box
            if (selectionBoxCreated)
            {
              ShowSelectedGroup();
              selectionBox.destroy();
              selectionBoxCreated = false;
            }
          }

          //If there is a group of selected components...
          if (selectedComponents.length > 0)
          {
            //clear the selected Id and previously selected Id.
            selectedId = "";
          }

          //clear flags for next selection
          compInSelectedGroup = false;
          mouseDownOnComponent = false;
        }
      });

      // For now use double click to enable/disable background image dragging.
      stage.getContent().addEventListener("dblclick", () => {
        if (designMode) {
          if (allow_bgImg_selection)
          {
            if (bgImage_layer.hasChildren()) {

              draggingToSelectComponents = false;

              let bgImg = bgImage_layer.getChildren()[0];

              if (bgImg.draggable()) {
                bgImg.draggable(false);
                bgImg.strokeEnabled(false);
              } else {
                bgImg.draggable(true);
                bgImg.strokeEnabled(true);
                document.getElementById("position_display_textbox").value = "  x = " +
                bgImage_layer.getChildren()[0].x() + ", y = " + 
                bgImage_layer.getChildren()[0].y();
              }
              bgImage_layer.draw();
            }
          }
        }
      });
    </script>
  </body>
</html>
